<?php
/*
|| Raffles 5 LITE
|| Created by Snog (NHawk on vBulletin.org)
*/

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'raffleadmin');
require_once(dirname(__FILE__) . '/global.php');
$vb5_config =& vB::getConfig();
$config = vB5_Config::instance();
$baseurl = $config->baseurl;
require_once(DIR . '/includes/functions_misc.php');
$dformat = substr(vB::getDatastore()->getOption('dateformat'),0,1);
if($dformat == 'm' || $dformat == 'n' || $dformat == 'F' || $dformat == 'M')
{
	$dformat = 'm/d/Y';
}else{
	$dformat = 'd-m-Y';
}
if (empty($_REQUEST['do'])) $_REQUEST['do'] = 'settings';
if($_REQUEST['do'] == 'settings') header("Location: options.php?do=options&dogroup=raffle");
if($_REQUEST['do'] == 'edit')
{
	print_cp_header($vbphrase['raffle_edit']);
	print_table_start();
	print_table_header($vbphrase['raffle_edit'], 5);
	print_form_header('raffleadmin','addnew');
	$raffles = $assertor->assertQuery('raffles5:getRafflesShowOld');
	print_cells_row(array($vbphrase['raffle_name'], $vbphrase['raffle_drawdate'], $vbphrase['raffle_shortentries'], $vbphrase['raffle_numprizes'], '<center>' . $vbphrase['options'] . '</center>'), 1, 'tcat');
	foreach($raffles as $raffle)
	{
		$raffle['enddate'] = vbdate($dformat, $raffle['enddate']);
		$cell = array();
		$cell[] = "<strong><a href=\"raffleadmin.php?do=view&id=$raffle[id]\" title=\"$raffle[name]\" />$raffle[name]</strong></a>";
		$cell[] = $raffle['enddate'];
		$cell[] = $raffle['numentries'];
		$cell[] = $raffle['numprizes'];
		$confirm = construct_phrase($vbphrase['raffle_delete_raffleconfirm'], $raffle[name]);
		if(!$raffle['winner'])
		{
			$cell[] = "<div align='center'><a href=\"raffleadmin.php?do=modify&id=$raffle[id]\">" . $vbphrase['raffle_modify'] . "</a> | <a href=\"raffleadmin.php?do=delete&id=$raffle[id]\" onClick=\"return confirm('$confirm')\">$vbphrase[delete]</a></div>";
		}
		else
		{
			$cell[] = "<div align='center'>" . $vbphrase['raffle_drawn'] . " | <a href=\"raffleadmin.php?do=delete&id=$raffle[id]\" onClick=\"return confirm('$confirm')\">$vbphrase[delete]</a></div>";
		}
		print_cells_row($cell);
	}
	print_submit_row($vbphrase['raffle_addnew'], 0, 5);
	print_table_footer();
	print_cp_footer();
	exit;
}
if($_REQUEST['do'] == 'addnew')
{
	$groups = array();
	$usergroups = $assertor->getRows('raffles5:getUsergroups');
	print_cp_header($vbphrase['raffle_addnew']);
	print_table_start();
	print_table_header($vbphrase['raffle_addnew']);
	print_form_header('raffleadmin','insertnew',1);
	print_input_row($vbphrase['raffle_name'], 'name');
	print_textarea_row($vbphrase['raffle_cpdescription'], 'description');
	print_textarea_row($vbphrase['raffle_cprules'], 'rules');
	print_input_row($vbphrase['raffle_quantity'], 'numprizes');
	print_input_row($vbphrase['raffle_prizeimg'], 'prizeimg');
	print_upload_row($vbphrase['raffle_upload'], 'ufile', 10000000, 50);
	print_yes_no_row($vbphrase['raffle_showimage'], 'showimage', 0);
	print_input_row($vbphrase['raffle_admin_startdate'], 'startdate', vbdate($dformat, TIMENOW));
	print_input_row($vbphrase['raffle_cp_drawdate'], 'drawdate','');
	print_input_row($vbphrase['raffle_draw_time'], 'drawtime', '10:00');
	print_input_row($vbphrase['raffle_stopdate'], 'stopdate', '');
	print_input_row($vbphrase['raffle_stoptime'], 'stoptime', '09:59');
	print_input_row($vbphrase['raffle_numentries'], 'numentries', '1');
	print_input_row($vbphrase['raffle_entrydelay'], 'entrydelay', '0');
	print_input_row($vbphrase['raffle_maxin_period'], 'maxperiod', '1');
	print_yes_no_row($vbphrase['raffle_allow_multiple'], 'multiple', 0);
	print_input_row($vbphrase['raffle_reqpost'], 'reqpost', '0');
	$grouptext .= "<tr>\n";
	$nogrouptext .= "<tr>\n";
	foreach($usergroups as $usergroup)
	{
		if(!in_array($usergroup['usergroupid'],explode(',', vB::getDatastore()->getOption('raffle_perms'))))
		{
			$grouptext .= "<td><input type=\"checkbox\" name=\"groupperm[" . $usergroup['usergroupid'] . "]\" value=\"" . $usergroup['usergroupid'] . "\" />" . $usergroup['title'] . "</td>\n";
			$grouptext .= "</tr>\n";
			$nogrouptext .= "<td><input type=\"checkbox\" name=\"nogroup[" . $usergroup['usergroupid'] . "]\" value=\"" . $usergroup['usergroupid'] . "\" />" . $usergroup['title'] . "</td>\n";
			$nogrouptext .= "</tr>\n";
		}
	}
	$grouptext .= "</tr>\n";
	$nogrouptext .= "</tr>\n";
	print_label_row($vbphrase['raffle_groupperm'], '<table cellspacing="2" cellpadding="0" border="0">' . $grouptext . '</tr></table>', '', 'top', 'usergroups');
	print_label_row($vbphrase['raffle_nogroup'], '<table cellspacing="2" cellpadding="0" border="0">' . $nogrouptext . '</tr></table>', '', 'top', 'usergroups');
	print_submit_row($vbphrase['raffle_addnew'], 0);
	print_table_footer();
	print_cp_footer();
	unset($usergroups, $groups);
	exit;
}
if($_POST['do'] == 'insertnew')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'name' => vB_Cleaner::TYPE_STR, 
		'description' => vB_Cleaner::TYPE_NOTRIM, 
		'drawdate' => vB_Cleaner::TYPE_STR,
		'drawtime' => vB_Cleaner::TYPE_STR,
		'stopdate' => vB_Cleaner::TYPE_STR,
		'stoptime' => vB_Cleaner::TYPE_STR,
		'startdate' => vB_Cleaner::TYPE_STR,
		'rules' => vB_Cleaner::TYPE_NOTRIM,
		'cost' => vB_Cleaner::TYPE_INT,
		'reqpost' => vB_Cleaner::TYPE_INT,
		'groupperm' => vB_Cleaner::TYPE_ARRAY,
		'nogroup' => vB_Cleaner::TYPE_ARRAY,
		'numentries' => vB_Cleaner::TYPE_INT,
		'multiple' => vB_Cleaner::TYPE_INT,
		'entrydelay' => vB_Cleaner::TYPE_INT,
		'maxperiod' => vB_Cleaner::TYPE_INT,
		'numprizes' => vB_Cleaner::TYPE_INT,
		'prizeimg' => vB_Cleaner::TYPE_STR,
		'showimage' => vB_Cleaner::TYPE_INT
	));
	if (is_array($passed_vars['groupperm']))
	{
		$groupperm = implode(',', $passed_vars['groupperm']);
	}else if ($passed_vars['groupperm'])
	{
		$groupperm = intval($passed_vars['groupperm']);
	}
	if (is_array($passed_vars['nogroup']))
	{
		$nogroup = implode(',', $passed_vars['nogroup']);
	}else if ($passed_vars['nogroup'])
	{
		$nogroup = intval($passed_vars['nogroup']);
		if($nogroup == 0) $nogroup = '';
	}
	if (empty($passed_vars['name']) OR empty($passed_vars['description']) OR empty($passed_vars['drawdate']) OR empty($passed_vars['stopdate'])) print_stop_message('raffle_missing_fields');
	if (empty($passed_vars['groupperm'])) print_stop_message('raffle_usergroup_missing');
	if (empty($passed_vars['cost']))
	{
		$cost = 0;
	}else{
		$cost = intval($passed_vars['cost']);
	}
	if ($passed_vars['numentries'] <= 0) $passed_vars['numentries'] = 1;
	if ($passed_vars['maxperiod'] > $passed_vars['numentries']) $passed_vars['maxperiod'] = $passed_vars['numentries'];
	if ($passed_vars['maxperiod'] <= 0) $passed_vars['maxperiod'] = 1;
	if ($passed_vars['numentries'] <= 0) $passed_vars['numentries'] = 1;
	$drawtime_parts = explode(':',$passed_vars['drawtime']);
	$drawtime = $drawtime_parts[0] * 3600;
	$drawtime = $drawtime + ($drawtime_parts[1] * 60);
	$endtime = strtotime($passed_vars['drawdate']) + $drawtime;
	$stoptime_parts = explode(':',$passed_vars['stoptime']);
	$stoptime = $stoptime_parts[0] * 3600;
	$stoptime = $stoptime + ($stoptime_parts[1] * 60);
	$stopdate = strtotime($passed_vars['stopdate']) + $stoptime;
	if ($stopdate >= $endtime) print_stop_message('raffle_bad_stopdate');
	$startdate = strtotime($passed_vars['startdate']);
	$rafflewrite = array(name => $passed_vars['name'],
				description => $passed_vars['description'],
				startdate => $startdate,
				enddate => $endtime,
				drawtime => $passed_vars['drawtime'],
				stopdate => $stopdate,
				stoptime => $passed_vars['stoptime'],
				rules => $passed_vars['rules'],
				cost => intval($passed_vars['cost']),
				reqpost => intval($passed_vars['reqpost']),
				groupperm => $groupperm,
				nogroup => $nogroup,
				numentries => intval($passed_vars['numentries']),
				entrydelay => intval($passed_vars['entrydelay']),
				maxperiod => intval($passed_vars['maxperiod']),
				numprizes => intval($passed_vars['numprizes']),
				prizeimg => $passed_vars['prizeimg'],
				showimage => intval($passed_vars['showimage']),
				multiple => intval($passed_vars['multiple']));
	$raffle_id = $assertor->insert('raffle', $rafflewrite); 
	if($_FILES['ufile']['name'])
	{
		$fileinfo = $assertor->getRows('raffles5:getFileTypes');
		$filetypes = '';
		foreach($fileinfo as $fileinfos)
		{
			if($filetypes) $filetypes .= ',';
			$filetypes .= $fileinfos['extension'];
		}
		$filepath = DIR . '/packages/raffles5/images';
		$pos = strrpos($_FILES['ufile']['name'],'.');
		if($pos == false)
		{
			print_stop_message('raffles_upload_notype');
		}else{
			$extension = strtolower(substr($_FILES['ufile']['name'], $pos + 1));
		}
		if(!in_array($extension,explode(',',strtolower($filetypes))))
		{
			print_stop_message('raffles_upload_notallowed');
		}
		$CleanFile = $_FILES['ufile']['name'];
		$CleanFile = str_replace("#", "_Number_", $CleanFile);
		$CleanFile = str_replace("$", "_Dollar_", $CleanFile);
		$CleanFile = str_replace("%", "_Percent_", $CleanFile);
		$CleanFile = str_replace("^", "", $CleanFile);
		$CleanFile = str_replace("&", "_and_", $CleanFile); 
		$CleanFile = str_replace("*", "", $CleanFile);
		$CleanFile = str_replace("?", "", $CleanFile);
		$filepath .= '/';
		if(!is_dir($filepath))
		{
			mkdir($filepath, 0775, true);
			chmod($filepath, 0775);
			$filehandle = fopen($filepath . 'index.html', "w");
			fclose($filehandle);
		}
		$uploaddir = $filepath;
		$path = $uploaddir.$CleanFile; 
		if($CleanFile)
		{
			if(copy($_FILES['ufile']['tmp_name'], $path))
			{
				$thisFileName = 'core/packages/raffles5/images/' . $CleanFile;
				$already_uploaded = $assertor->getRow('raffles5:getRaffleImage', array('id' => intval($raffle_id), 'prizeimg' => $thisFileName));
				if(!$already_uploaded) $assertor->update('raffle', array('prizeimg' => $thisFileName), array('id' => intval($raffle_id))); 
			}else{
				print_stop_message('raffles_upload_error');
			}
		}
	}
	log_admin_action('Added: '. $passed_vars['name']);
	print_stop_message2('raffle_added','raffleadmin',array('do'=>'edit'));
	exit;
}
if($_REQUEST['do'] == 'modify')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'id' => vB_Cleaner::TYPE_INT
	));
	$raffleid = $passed_vars['id'];
	$raffle = $assertor->getRow('raffles5:getRaffleDetails', array('id' => intval($raffleid)));
	$groups = explode(',', $raffle['groupperm']);
	$nogroups = explode(',', $raffle['nogroup']);
	$usergroups = $assertor->getRows('raffles5:getUsergroups');
	$drawdate = vbdate($dformat, $raffle['enddate']);
	$stopdate = vbdate($dformat, $raffle['stopdate']);
	$startdate = vbdate($dformat, $raffle['startdate']);
	print_cp_header($vbphrase['raffle_modify']);
	print_table_start();
	print_table_header("$vbphrase[raffle_modify]: $raffle[name]");
	print_form_header('raffleadmin','update',1);
	construct_hidden_code('id', $raffle['id']);
	print_input_row($vbphrase['raffle_name'], 'name', $raffle['name']);
	print_textarea_row($vbphrase['raffle_cpdescription'], 'description', $raffle['description']);
	print_textarea_row($vbphrase['raffle_cprules'], 'rules', $raffle['rules']);
	print_input_row($vbphrase['raffle_quantity'], 'numprizes', $raffle['numprizes']);
	print_input_row($vbphrase['raffle_prizeimg'], 'prizeimg', $raffle['prizeimg']);
	print_upload_row($vbphrase['raffle_upload'], 'ufile', 10000000, 50);
	print_yes_no_row($vbphrase['raffle_showimage'], 'showimage', $raffle['showimage']);
	print_input_row($vbphrase['raffle_admin_startdate'], 'startdate', $startdate);
	print_input_row($vbphrase['raffle_cp_drawdate'], 'drawdate', $drawdate);
	print_input_row($vbphrase['raffle_draw_time'], 'drawtime', $raffle['drawtime']);
	print_input_row($vbphrase['raffle_stopdate'], 'stopdate', $stopdate);
	print_input_row($vbphrase['raffle_stoptime'], 'stoptime', $raffle['stoptime']);
	print_input_row($vbphrase['raffle_numentries'], 'numentries', $raffle['numentries']);
	print_input_row($vbphrase['raffle_entrydelay'], 'entrydelay', $raffle['entrydelay']);
	print_input_row($vbphrase['raffle_maxin_period'], 'maxperiod', $raffle['maxperiod']);
	print_yes_no_row($vbphrase['raffle_allow_multiple'], 'multiple', $raffle['multiple']);
	print_input_row($vbphrase['raffle_reqpost'], 'reqpost', $raffle['reqpost']);
	$grouptext .= "<tr>\n";
	$nogrouptext .= "<tr>\n";
	foreach($usergroups as $usergroup)
	{
		if(!in_array($usergroup['usergroupid'],explode(',', vB::getDatastore()->getOption('raffle_perms'))))
		{
			if(in_array($usergroup['usergroupid'],$groups))
			{
				$checked = "checked";
			}
			else
			{
				$checked = "";
			}
			if(in_array($usergroup['usergroupid'],$nogroups))
			{
				$nochecked = "checked";
			}
			else
			{
				$nochecked = "";
			}

			$grouptext .= "<td><input type=\"checkbox\" name=\"groupperm[" . $usergroup['usergroupid'] . "]\" value=\"" . $usergroup['usergroupid'] . "\" $checked />" . $usergroup['title'] . "</td>\n";
			$grouptext .= "</tr>\n";
			$nogrouptext .= "<td><input type=\"checkbox\" name=\"nogroup[" . $usergroup['usergroupid'] . "]\" value=\"" . $usergroup['usergroupid'] . "\" $nochecked />" . $usergroup['title'] . "</td>\n";
			$nogrouptext .= "</tr>\n";
		}
	}
	$grouptext .= "</tr>\n";
	$nogrouptext .= "</tr>\n";
	print_label_row($vbphrase['raffle_groupperm'], '<table cellspacing="2" cellpadding="0" border="0">' . $grouptext . '</tr></table>', '', 'top', 'usergroups');
	print_label_row($vbphrase['raffle_nogroup'], '<table cellspacing="2" cellpadding="0" border="0">' . $nogrouptext . '</tr></table>', '', 'top', 'usergroups');
	print_submit_row($vbphrase['raffle_update'], 0);
	print_table_footer();
	print_cp_footer();
	exit;
}
if($_POST['do'] == 'update')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'id' => vB_Cleaner::TYPE_INT,
		'name' => vB_Cleaner::TYPE_STR, 
		'description' => vB_Cleaner::TYPE_NOTRIM, 
		'startdate' => vB_Cleaner::TYPE_STR,
		'drawdate' => vB_Cleaner::TYPE_STR,
		'drawtime' => vB_Cleaner::TYPE_STR,
		'stopdate' => vB_Cleaner::TYPE_STR,
		'stoptime' => vB_Cleaner::TYPE_STR,
		'rules' => vB_Cleaner::TYPE_NOTRIM,
		'cost' => vB_Cleaner::TYPE_INT,
		'reqpost' => vB_Cleaner::TYPE_INT,
		'groupperm' => vB_Cleaner::TYPE_ARRAY,
		'nogroup' => vB_Cleaner::TYPE_ARRAY,
		'numentries' => vB_Cleaner::TYPE_INT,
		'multiple' => vB_Cleaner::TYPE_INT,
		'entrydelay' => vB_Cleaner::TYPE_INT,
		'maxperiod' => vB_Cleaner::TYPE_INT,
		'numprizes' => vB_Cleaner::TYPE_INT,
		'prizeimg' => vB_Cleaner::TYPE_STR,
		'showimage' => vB_Cleaner::TYPE_INT
	));
	if (is_array($passed_vars['groupperm']))
	{
		$groupperm = implode(',', $passed_vars['groupperm']);
	}
	else if ($passed_vars['groupperm'])
	{
		$groupperm = intval($passed_vars['groupperm']);
	}
	if (is_array($passed_vars['nogroup']))
	{
		$nogroup = implode(',', $passed_vars['nogroup']);
	}else if ($passed_vars['nogroup'])
	{
		$nogroup = intval($passed_vars['nogroup']);
		if($nogroup == 0) $nogroup = '';
	}
	if (empty($passed_vars['name']) OR empty($passed_vars['description']) OR empty($passed_vars['drawdate'])) print_stop_message('raffle_missing_fields');
	if (empty($passed_vars['groupperm'])) print_stop_message('raffle_usergroup_missing');
	if ($passed_vars['numentries'] <= 0) $passed_vars['numentries'] = 1;
	if ($passed_vars['maxperiod'] > $passed_vars['numentries']) $passed_vars['maxperiod'] = $passed_vars['numentries'];
	if ($passed_vars['maxperiod'] <= 0) $passed_vars['maxperiod'] = 1;
	$drawtime_parts = explode(':',$passed_vars['drawtime']);
	$drawtime = $drawtime_parts[0] * 3600;
	$drawtime = $drawtime + ($drawtime_parts[1] * 60);
	$endtime = strtotime($passed_vars['drawdate']) + $drawtime;
	$stoptime_parts = explode(':',$passed_vars['stoptime']);
	$stoptime = $stoptime_parts[0] * 3600;
	$stoptime = $stoptime + ($stoptime_parts[1] * 60);
	$stopdate = strtotime($passed_vars['stopdate']) + $stoptime;
	if ($stopdate >= $endtime) print_stop_message('raffle_bad_stopdate');
	$startdate = strtotime($passed_vars['startdate']);
	$rafflewrite = array(name => $passed_vars['name'],
				description => $passed_vars['description'],
				startdate => $startdate,
				enddate => $endtime,
				drawtime => $passed_vars['drawtime'],
				stopdate => $stopdate,
				stoptime => $passed_vars['stoptime'],
				rules => $passed_vars['rules'],
				cost => intval($passed_vars['cost']),
				reqpost => intval($passed_vars['reqpost']),
				groupperm => $groupperm,
				nogroup => $nogroup,
				numentries => intval($passed_vars['numentries']),
				entrydelay => intval($passed_vars['entrydelay']),
				maxperiod => intval($passed_vars['maxperiod']),
				numprizes => intval($passed_vars['numprizes']),
				prizeimg => $passed_vars['prizeimg'],
				showimage => intval($passed_vars['showimage']),
				multiple => intval($passed_vars['multiple']));
	$assertor->update('raffle', $rafflewrite, array('id' => intval($passed_vars['id']))); 
	$raffle_id = intval($passed_vars['id']);
	if($_FILES['ufile']['name'])
	{
		$fileinfo = $assertor->getRows('raffles5:getFileTypes');
		$filetypes = '';
		foreach($fileinfo as $fileinfos)
		{
			if($filetypes) $filetypes .= ',';
			$filetypes .= $fileinfos['extension'];
		}
		$filepath = DIR . '/packages/raffles5/images';
		$pos = strrpos($_FILES['ufile']['name'],'.');
		if($pos == false)
		{
			print_stop_message('raffles_upload_notype');
		}else{
			$extension = strtolower(substr($_FILES['ufile']['name'], $pos + 1));
		}
		if(!in_array($extension,explode(',',strtolower($filetypes))))
		{
			print_stop_message('raffles_upload_notallowed');
		}
		$CleanFile = $_FILES['ufile']['name'];
		$CleanFile = str_replace("#", "_Number_", $CleanFile);
		$CleanFile = str_replace("$", "_Dollar_", $CleanFile);
		$CleanFile = str_replace("%", "_Percent_", $CleanFile);
		$CleanFile = str_replace("^", "", $CleanFile);
		$CleanFile = str_replace("&", "_and_", $CleanFile); 
		$CleanFile = str_replace("*", "", $CleanFile);
		$CleanFile = str_replace("?", "", $CleanFile);
		$filepath .= '/';
		if(!is_dir($filepath))
		{
			mkdir($filepath, 0775, true);
			chmod($filepath, 0775);
			$filehandle = fopen($filepath . 'index.html', "w");
			fclose($filehandle);
		}
		$uploaddir = $filepath;
		$path = $uploaddir.$CleanFile; 
		if($CleanFile)
		{
			if(copy($_FILES['ufile']['tmp_name'], $path))
			{
				$thisFileName = 'core/packages/raffles5/images/' . $CleanFile;
				$already_uploaded = $assertor->getRow('raffles5:getRaffleImage', array('id' => intval($raffle_id), 'prizeimg' => $thisFileName));
				if(!$already_uploaded) $assertor->update('raffle', array('prizeimg' => $thisFileName), array('id' => intval($raffle_id))); 
			}else{
				print_stop_message('raffles_upload_error');
			}
		}
	}
	log_admin_action('Edited: '. $passed_vars['name']);
	print_stop_message2('raffle_updated','raffleadmin',array('do'=>'edit'));
	exit;
}
if ($_REQUEST['do'] == 'delete')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'id' => vB_Cleaner::TYPE_INT
	));
	$id = $passed_vars['id'];
	if (!intval($id)) print_stop_message('raffle_nonexistent');
	$assertor->delete('raffle', array('id' => intval($id))); 
	$assertor->delete('raffle_entries', array('raffleid' => intval($id)));
	log_admin_action('Deleted raffle ID: '. $id);
	print_stop_message2('raffle_deleted','raffleadmin',array('do'=>'edit'));
	exit;
}

if($_REQUEST['do'] == 'view')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'id' => vB_Cleaner::TYPE_INT
	));
	$id = $passed_vars['id'];
	$raffle = $assertor->getRow('raffles5:getRaffleDetails', array('id' => intval($id)));
	if (!$raffle['id']) print_stop_message('raffle_nonexistent');
	$raffle['startdate'] = vbdate($dformat, $raffle['startdate']);
	$raffle['enddate'] = vbdate($dformat, $raffle['enddate']);
	$raffle['description'] = nl2br($raffle['description']);
	$raffle['rules'] = nl2br($raffle['rules']);
	if(empty($raffle['prizeimg']))
	{
		$prizeimg = "<img src=\"../core/packages/raffles5/images/default.gif\" />";
	}else{
		$prizeimg = "<img src=\"../$raffle[prizeimg]\" />";
	}
	print_cp_header($vbphrase['raffle_view']);
	print_table_start();
	print_table_header("$vbphrase[raffle_view]: $raffle[name]");
	if(!$raffle['winner'])
	{
		print_form_header('raffleadmin','draw');
		construct_hidden_code('id', $raffle['id']);
		construct_hidden_code('name', $raffle['name']);
	}
	print_label_row($vbphrase['raffle_name'], $raffle['name']);
	print_label_row($vbphrase['raffle_description'], $raffle['description']);
	print_label_row($vbphrase['raffle_prizeimg'], $prizeimg);
	print_label_row($vbphrase['raffle_admin_startdate'], $raffle['startdate']);
	print_label_row($vbphrase['raffle_drawdate'], $raffle['enddate']);
	print_label_row($vbphrase['raffle_rules'], $raffle['rules']);
	print_label_row($vbphrase['raffle_reqpost'], $raffle['reqpost']);
	print_label_row($vbphrase['raffle_groupperm'], $raffle['groupperm']);
	print_label_row($vbphrase['raffle_nogroup'], $raffle['nogroup']);
	print_label_row($vbphrase['raffle_numentries'], $raffle['numentries']);
	print_label_row($vbphrase['raffle_entrydelay'], $raffle['entrydelay']);
	print_label_row($vbphrase['raffle_maxin_period'], $raffle['maxperiod']);
	print_label_row($vbphrase['raffle_quantity'], $raffle['numprizes']);
	print_label_row($vbphrase['raffle_winner'], $raffle['winner']);
	if(!$raffle['winner']) print_submit_row($vbphrase['raffle_draw'], 0);
	print_table_footer();
	print_cp_footer();
	exit;
}
if ($_POST['do'] == 'draw')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'id' => TYPE_INT,
		'name' => TYPE_STR
	));
	$raffleid = intval($passed_vars['id']);
	$rafflename = $passed_vars['name'];
	$mytime = time();
	$userInfo = vB_User::fetchUserinfo();
	log_admin_action('Manual Draw Raffleadmin v5.0.0', $userinfo['userid'],'raffleadmin');
	$sender = vB_User::fetchUserinfo(vB::getDatastore()->getOption('raffle_adminid'));
	$raffle = $assertor->getRow('raffles5:getRaffleDetails', array('id' => $raffleid));
	$winner_count = 0;
	$winner_ids = '';
	$winner_list = '';
	if(vB::getDatastore()->getOption('raffle_debug') && !$raffle['winner'])
	{
		$debug_time = time();
		log_admin_action('Multiple Winners = ' . $raffle['multiple'], $userinfo['userid'],'raffleadmin');
		log_admin_action('Drawing ' . $raffle['name'], $userinfo['userid'],'raffleadmin');
	}
	$drawdate = vbdate(vB::getDatastore()->getOption('dateformat'), $mytime);
	if(!$raffle['multiple'])
	{
		$entrycount = $assertor->assertQuery('raffles5:getRaffleUniqueEntries',array('id' => $raffle['id']));
		$number_entered = $assertor->affected_rows($entrycount);
		if($number_entered < $raffle['numprizes'])
		{
			$errmsg = construct_phrase($vbphrase['raffle_draw_error'], $raffle['name'], $number_entered, $raffle['numprizes']);
			log_admin_action($errmsg, $userinfo['userid'],'raffleadmin');
			print_stop_message('raffle_cpdraw_error', $raffle['name'], $number_entered, $raffle['numprizes']);
		}
	}
	while($winner_count < $raffle['numprizes'])
	{
		$rid = $raffle['id'];
		$winner = $assertor->getRow('raffles5:getRaffleWinner',array('id' => $rid));
		if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Conditional Winner: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
		if(!$raffle['multiple'] && $winner_list)
		{
			if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('In Duplicate Check: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
			while(in_array($winner['userid'], explode(",",$winner_ids)))
			{
				$winner = $assertor->getRow('raffles5:getRaffleWinner',array('id' => $rid));
			}
			if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Finalized Winner: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
		}
		if(!$winner['userid'])
		{
			$errmsg = construct_phrase($vbphrase['raffle_draw_error'], $raffle['name'], '0', $raffle['numprizes']);
			$winner_info = $vbphrase['raffle_noentries'];
			$assertor->update('raffle', array(
					'winner' => $winner_info 
					),
					array('id' => $raffle['id'])
			); 
			log_admin_action('raffle_draw_error', $raffle['name'], '0', $raffle['numprizes'], $userinfo['userid'],'raffleadmin');
			print_stop_message('raffle_cpdraw_error', $raffle['name'], $number_entered, $raffle['numprizes']);
			break;
		}else{
			$winner_count = $winner_count + 1;
		}
		if($raffle['numprizes'] == 1 && $winner['userid'])
		{	
			if(!vB::getDatastore()->getOption('raffle_display_tickets'))
			{
				$winner_info = $winner['username'];
			}else{
				$winner_info = $winner['username'] . " (" . $vbphrase['raffle_ticketnumber'] . $winner['entryid'] . ")";
			}
			$assertor->update('raffle', array(
					'winner' => $winner_info 
					),
					array('id' => $raffle['id'])
			); 
			if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Single Prize Winner Recorded: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
			$subject = $vbphrase['raffle_message_subject'];
			$message = construct_phrase($vbphrase['raffle_message_salute'], $winner[username]) . "\n\r\n\r";
			$message .= construct_phrase($vbphrase['raffle_message_body'], $raffle['name'], $drawdate) . "\n\r\n\r";;
			$message .= construct_phrase($vbphrase['raffle_message_close'], $sender['username'], $vbphrase['raffle_admin_title']);
			if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Sending PM To: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
			$data = array(
				'msgRecipients'=>$winner[username],
				'title'=>$subject,
				'userid'=>$sender['userid'],
				'rawtext'=>$message
			);
			$pm = Raffles5_Library_Content_Privatemessage::add($data);
			$winner_list = $winner_info;
			$drawnmsg = construct_phrase($vbphrase['raffle_autodrawn'], $raffle['name'], $winner_info);
			log_admin_action($drawnmsg, $userinfo['userid'],'raffleadmin');
		}else{
			if($winner['userid'])
			{
				if(!vB::getDatastore()->getOption('raffle_display_tickets'))
				{
					$winner_info = $winner['username'];
				}else	{
					$winner_info = $winner['username'] . " (" . $vbphrase['raffle_ticketnumber'] . $winner['entryid'] . ")";
				}
				if($winner_list)
				{
					$winner_list .= ", " . $winner_info;
					$winner_ids .= "," . $winner['userid'];
				}else{
					$winner_list = $winner_info;
					$winner_ids .= $winner['userid'];
				}
				if(vB::getDatastore()->getOption('raffle_debug'))
				{
					log_admin_action('Current Winner List: ' . $winner_list, $userinfo['userid'],'raffleadmin');
					log_admin_action('Current Winner IDs: ' . $winner_ids, $userinfo['userid'],'raffleadmin');
				}
				if($winner_count == $raffle['numprizes'])
				{
					$assertor->update('raffle', array(
							'winner' => $winner_list 
							),
							array('id' => $raffle['id'])
					); 
					if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Winners Recorded in DB: ' . $winner_list, $userinfo['userid'],'raffleadmin');
				}
				$subject = $vbphrase['raffle_message_subject'];
				$message = construct_phrase($vbphrase['raffle_message_salute'], $winner[username]) . "\n\r\n\r";
				$message .= construct_phrase($vbphrase['raffle_message_body'], $raffle['name'], $drawdate) . "\n\r\n\r";;
				$message .= construct_phrase($vbphrase['raffle_message_close'], $sender['username'], $vbphrase['raffle_admin_title']);
				if(vB::getDatastore()->getOption('raffle_debug')) log_admin_action('Sending PM To: ' . $winner['userid'], $userinfo['userid'],'raffleadmin');
				$data = array(
					'msgRecipients'=>$winner[username],
					'title'=>$subject,
					'userid'=>$sender['userid'],
					'rawtext'=>$message
				);
				$pm = Raffles5_Library_Content_Privatemessage::add($data);
				if(!vB::getDatastore()->getOption('raffle_debug'))
				{
					$drawnmsg = construct_phrase($vbphrase['raffle_autodrawn'], $raffle['name'], $winner_info);
					log_admin_action($drawnmsg, $userinfo['userid'],'raffleadmin');
				}
			}
		}
	}
	$drawn = construct_phrase($vbphrase['raffle_cpdrawn'], $raffle['name'], $winner_list);
	print_stop_message2($drawn,'raffleadmin',array('do'=>'edit'));
	exit;
}
if($_REQUEST['do'] == 'delentry')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'entryid' => vB_Cleaner::TYPE_INT
	));
	$entryid = $passed_vars['entryid'];
	$assertor->delete('raffle_entries', array('entryid' => intval($entryid))); 
	log_admin_action('Deleted entry ID: '. $entryid);
	print_stop_message2('raffle_entry_deleted','raffleadmin',array('do'=>'userentries'));
	exit;
}
if ($_REQUEST['do'] == 'userentries')
{

	$raffles = $assertor->getRows('raffles5:getRaffleNames');
	$rafflelist = array();
	$rafflelist[0] = 'All Raffles';
	foreach($raffles as $raffle)
	{
		$rafflelist[$raffle['id']] = $raffle['name'];
	}
	$perpage = array(5 => 5, 10 => 10, 15 => 15, 20 => 20, 25 => 25, 30 => 30, 40 => 40, 50 => 50, 100 => 100);
	$orderby = array('date' => $vbphrase['date'], 'raffle' => 'Raffle', 'userid' => 'Userid', 'username' => 'User Name');
	print_cp_header($vbphrase['raffle_entries']);
	print_table_start();
	print_table_header($vbphrase['raffle_entries'], 6);
	print_form_header('raffleadmin', 'showentries');
	print_select_row('Entries to show per page', 'perpage', $perpage, 15);
	print_select_row('Show only entries for', 'varname', $rafflelist);
	print_select_row($vbphrase['order_by'], 'orderby', $orderby);
	print_submit_row($vbphrase['view'], 0);
	print_table_footer();
	print_cp_footer();
	exit;
}
if ($_REQUEST['do'] == 'showentries')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'perpage' => TYPE_INT,
		'varname' => TYPE_INT,
		'orderby' => TYPE_STR,
		'page'    => TYPE_INT
	));
	if (empty($passed_vars['perpage'])) $passed_vars['perpage'] = 15;

	$sqlconds = '';
	if (!empty($passed_vars['varname']))
	{
		$sqlconds = intval($passed_vars['varname']);
		$counterquery = $assertor->getRows('raffles5:getRaffleEntryCount', array('raffleid' => intval($passed_vars['varname'])));
		$counter = $assertor->affected_rows($counterquery);
	}else{
		$counterquery = $assertor->getRows('raffles5:getRaffleAllEntryCount');
		$counter = $assertor->affected_rows($counterquery);
	}

	$totalpages = ceil($counter / $passed_vars['perpage']);
	if (empty($passed_vars['page'])) $passed_vars['page'] = 1;
	$startat = ($passed_vars['page'] - 1) * $passed_vars['perpage'];
	switch ($passed_vars['orderby'])
	{
		case 'raffle':
			if (!empty($sqlconds))
			{
				$entries = $assertor->getRows('raffles5:getRaffleEntriesAllbyRaffleID',array('sqlconds' => $sqlconds, 'startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}else{
				$entries = $assertor->getRows('raffles5:getRaffleEntriesAllbyRaffle',array('startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}
			break;
		case 'date':
			if (!empty($sqlconds))
			{
				$entries = $assertor->getRows('raffles5:getRaffleIDbyDate',array('sqlconds' => $sqlconds, 'startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}else{
				$entries = $assertor->getRows('raffles5:getRaffleEntriesAllbyDate',array('startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}
			break;
		case 'userid':
			if(!empty($sqlconds))
			{
				$entries = $assertor->getRows('raffles5:getRaffleIDbyUserid',array('sqlconds' => $sqlconds, 'startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}else{
				$entries = $assertor->getRows('raffles5:getRaffleEntriesAllbyUserid',array('startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}
			break;
		case 'username':
			if(!empty($sqlconds))
			{
				$entries = $assertor->getRows('raffles5:getRaffleIDbyUsername',array('sqlconds' => $sqlconds, 'startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}else{
				$entries = $assertor->getRows('raffles5:getRaffleUserEntries',array('startat' => $startat, 'perpage' => $passed_vars['perpage']));
			}
			break;
		default:
			$entries = $assertor->getRows('raffles5:getRaffleEntriesAllbyDate',array('startat' => $startat, 'perpage' => $passed_vars['perpage']));
	}

	$entcount = $assertor->affected_rows($entries);
	if ($entcount)
	{
		if ($passed_vars['page'] != 1)
		{
			$prv = $passed_vars['page'] - 1;
			$firstpage = "<input type=\"button\" class=\"button\" tabindex=\"1\" value=\"&laquo; " . $vbphrase['first_page'] . "\" onclick=\"window.location='raffleadmin.php?" . vB::getCurrentSession()->get('sessionurl') . "do=showentries" .
				"&varname=" . urlencode($passed_vars['varname']) .
				"&pp=" . $passed_vars['perpage'] .
				"&orderby=" . urlencode($passed_vars['orderby']) . "&page=1'\">";
			$prevpage = "<input type=\"button\" class=\"button\" tabindex=\"1\" value=\"&lt; " . $vbphrase['prev_page'] . "\" onclick=\"window.location='raffleadmin.php?" . vB::getCurrentSession()->get('sessionurl') . "do=showentries" .
				"&varname=" . urlencode($passed_vars['varname']) .
				"&pp=" . $passed_vars['perpage'] .
				"&orderby=" . urlencode($passed_vars['orderby']) . "&page=$prv'\">";
		}
		if ($passed_vars['page'] != $totalpages)
		{
			$nxt = $passed_vars['page'] + 1;
			$page_button = "raffleadmin.php?" . vB::getCurrentSession()->get('sessionurl') . "do=showentries&varname=" . urlencode($passed_vars['varname']) . "&pp=" . $passed_vars['perpage'] . "&orderby=" . urlencode($passed_vars['orderby']);
			$nextpage = "<input type=\"button\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['next_page'] . " &gt;\" onclick=\"window.location='$page_button&page=$nxt'\">";
			$lastpage = "<input type=\"button\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['last_page'] . " &raquo;\" onclick=\"window.location='$page_button&page=$totalpages'\">";
		}
		print_cp_header($vbphrase['raffle_entries']);
		print_table_start();
		print_table_header($vbphrase['raffle_entries'], 6);

		print_description_row(construct_link_code($vbphrase['restart'], "raffleadmin.php?" . vB::getCurrentSession()->get('sessionurl') . "do=userentries"), 0, 6, 'thead', vB_Template_Runtime::fetchStyleVar('right'));

		print_form_header('raffleadmin', 'remove');
		print_cells_row(array($vbphrase['raffle_entryid'], $vbphrase['raffle_name'], $vbphrase['raffle_username'], $vbphrase['raffle_entrydate'], $vbphrase['raffle_ipaddr'], '<center>' . $vbphrase['options'] . '</center>'), 'tcat');
		foreach($entries as $entry)
		{
			$cell = array();
			$cell[] = '#' . $entry['entryid'];
			$cell[] = "<strong><a href=\"raffleadmin.php?do=view&id=$entry[raffleid]\" title=\"$entry[name]\" />$entry[name]</strong></a>";
			$cell[] = '<a href="' . $baseurl . 'member/' . $entry[userid] . '" target="_blank" />' . $entry[username] . '</a>';
			$cell[] = '<center>' . vbdate(vB::getDatastore()->getOption('dateformat'), $entry['entrydate']) . '</center>';
			$cell[] = '<center>' . $entry['ipaddress'] . '</center>';
			$confirm = construct_phrase($vbphrase['raffle_delete_entryconfirm'], $entry[username]);
			$cell[] = "<div align='center'><a href=\"raffleadmin.php?do=delentry&entryid=$entry[entryid]\" onClick=\"return confirm('$confirm')\">$vbphrase[delete]</a></div>";
			print_cells_row($cell, 0, 0, -4);
		}
		if(intval($passed_vars['varname']) > 0)
		{
			construct_hidden_code('varname', intval($passed_vars['varname']));
			$allconfirm = $vbphrase['raffle_delete_allconfirm'];
			$dellall = "<input type=\"submit\" id=\"submit0\" class=\"button\" tabindex=\"1\" value=\"Delete All Entries\" accesskey=\"s\" onClick=\"return confirm('$allconfirm')\" \/>";
			print_table_footer(6, "$firstpage $prevpage &nbsp; $dellall &nbsp; $nextpage $lastpage");
		}else{
			print_table_footer(6, "$firstpage $prevpage &nbsp; $nextpage $lastpage");
		}
		print_cp_footer();
	}
	else
	{
		print_stop_message('raffle_no_winner');
	}
	exit;
}
if ($_REQUEST['do'] == 'remove')
{
	$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
		'varname' => TYPE_INT
	));
	$assertor->delete('raffle_entries', array('raffleid' => intval($passed_vars['varname']))); 
	log_admin_action('Deleted all entries for raffle id: '. intval($passed_vars['varname']));
	print_stop_message2('raffle_entry_deleted','raffleadmin',array('do'=>'userentries'));
	exit;
}
?>
