<?php

class Raffles5_Api_Template extends vB_Api_Extensions
{
	public $product = 'raffles5';
	public $version = '5.0.4';	
	public $developer = 'Snog';
	public $title = 'Raffle Copyright';

	public static function bulk_fetch($result, $template_names, $styleid = -1, $type = 'compiled')
	{
		//=================================================
		// WORKAROUND UNTIL VB GIVES A WAY TO INSERT PAGES,
		// ROUTES, TEMPLATES AND WIDGET INSTANCES IN XML
		//=================================================
		$assertor = vB::getDbAssertor();
		$widgetinstance = $assertor->getRow('Raffles5:getRaffleEntryWidget');

		// Widget is missing due to upgrade or some other reason! Reinsert it!
		if(!$widgetinstance['widgetinstanceid'] && $widgetinstance['widgetid'])
		{
			$values = array('0', $widgetinstance['pagetemplateid'], $widgetinstance['widgetid'], '0', '0');
			$insertWidget = $assertor->assertQuery('Raffles5:raffleAddWidgetInstance', array('values' => $values));
		}
		// END WORKAROUND


		if (array_key_exists('footer', $result))
		{
            require_once(DIR . '/includes/class_template_parser.php');
            $parser = new vB_TemplateParser('<div id="footer-user-copyright">');
            $parser->dom_doc = new vB_DomDocument($parser->fetch_dom_compatible());
            $find = trim($parser->_parse_nodes($parser->dom_doc->childNodes()));

            $parser = new vB_TemplateParser("vBulletin Raffles LITE Copyright &copy; 2012 by Snog<br />");
            $parser->dom_doc = new vB_DomDocument($parser->fetch_dom_compatible());
            $replace = trim($parser->_parse_nodes($parser->dom_doc->childNodes()));

            $result['footer'] = str_replace($find, $find . $replace, $result['footer']);			
		}

	return $result;
	}
}
?>